/// This class contains functions
/// to get the variables for rsa
/// public key and private key
class RSAKey {
  /// This function is used to get the value of N
  int valueOfN(int p, int q) {
    return p * q;
  }

  /// This function is used to get the value of Z
  int valueOfZ(int p, int q) {
    return (p - 1) * (q - 1);
  }

  /// This function is used to get the value of E
  int valueOfE(int n, int z) {
    var e = 0;
    var bruteForceArea = [];

    /**
     * * Create squence of number for bruteforce 
     */
    for (int i = 1; i <= n; i++) {
      bruteForceArea.add(i);
    }

    /**
     * * Remove numbers that have same value as factor of Z
     */
    for (int i = 0; i < factorOfNumber(z).length; i++) {
      bruteForceArea.remove(factorOfNumber(z)[i]);
    }

    /**
     * * Find the value of e from filtered squence
     */
    for (int i = 0; i < bruteForceArea.length; i++) {
      if (isPrimeNumber(bruteForceArea[i]) == true) {
        e = bruteForceArea[i];
        break;
      }
    }
    return e;
  }

  /// This function is used to get the value of D
  int valueOfD(int n, int e, int z) {
    var d = 0;
    for (int i = 0; i < n; i++) {
      if (((e * i) - 1) % z == 0) {
        d = i;
        break;
      }
    }
    return d;
  }

  /**
   * * This is the function to print public and private key
   */
  /// Generate public and private key as text
  generateKey(int n, int z, int e, int d) {
    print("Variables generated:");
    print("n = ${n}\nz = ${z}\ne = ${e}\nd = ${d}");
    print("Public key (n,e) = (${n},${e})");
    print("Private key (n,d) = (${n},${d})");
  }

  /**
   * * Math tools for calculating
   * The code below provide math function
   * to help calculate and predicting value
   */
  List factorOfNumber(int n) {
    var factors = [];
    for (int i = 1; i <= n; ++i) {
      if (n % i == 0) {
        factors.add(i);
      }
    }
    return factors;
  }

  bool isPrimeNumber(int n) {
    bool isPrime = true;
    if (n == 0 || n == 1) {
      isPrime = false;
    } else {
      for (int i = 2; i <= n / 2; ++i) {
        if (n % i == 0) {
          isPrime = false;
          break;
        }
      }
    }
    return isPrime;
  }
}
